def filter(P, E, ys):
    pi = np.ones(MAX_STATE + 1) / (MAX_STATE + 1)
    for yn in ys:
        # Compute const * P(yn | xn) * Sum_{x_{n-1}} P(x_{n-1} | h) P(x_n | x_{n-1})
        pi = np.multiply(E[:, yn], pi @ P)
        # Normalise the probability vector.
        pi = pi / np.sum(pi)
    return pi
