eps = 0.01

def generate_transition_matrix():
    # Transition matrix. P[x,y] = Pr( y | x)
    P = (eps / (MAX_STATE + 1)) * np.ones((MAX_STATE + 1, MAX_STATE + 1))
    for x in range(MAX_STATE + 1):
        P[x, max(x-1, 0)] += 1 / 4 * (1 - eps)
        P[x, x] += 1 / 2 * (1 - eps)
        P[x, min(x + 1, MAX_STATE)] += 1 / 4 * (1 - eps)
    assert np.allclose(np.sum(P, axis=1), np.ones(MAX_STATE + 1))
    return P


print(filter(P, E, [3, 3, 4, 5, 4, 3, 3, 2, 2, 1, 2, 1, 2, 2]))
# Expected output: [0. 0.3749904  0.41518442 0.20982518 0. 0. 0. 0. 0. 0.]
# Contrast with  : [0. 0.37478324 0.41479646 0.2104203  0. 0. 0. 0. 0. 0.]

print(filter(P, E, [3, 3, 4, 9]))
# Expected output: [0. 0. 0. 0. 0. 0. 0. 0. 0.33333333 0.66666667]
# Contrast with  : [nan nan nan nan nan nan nan nan nan nan]
